#include "psgrnd.h"
#include <sys/times.h>
#include <time.h>

#define VERSION "psgrnd.2003.06.04"
int SetConditions(struct Snode *conditions);
void SetMetaConditions(struct Snode *conditions,struct Qnode *quantifiers,struct Snode *symbol, int bdy);
int UnSetConditions(struct Snode *conditions);
void AddRuleToList(struct Rnode *rule);
struct MetaAtom *NewMetaAtom(void);
struct MetaList *NewMetaList(void);
int Evaluate(struct Snode *sptr);
int CheckData(struct Pnode *dataptr, struct Snode *list);
void AddCond(struct Snode *conditions, struct Snode *cptr);
struct Snode *ParseLogCond(struct Snode *slist);
void AddToSnode(struct Snode *lptr,char *symbol);
struct Qnode *NewQNode(char *name,struct Pnode *dp);
struct Snode *NewSymbol(char *name);
struct Cnode *NewConst(char *name,char *val);
struct Vtemp *NewVarTemp(struct Pnode *dtype,char *name);
struct Pnode *NewData(char *name);
struct Pnode *NewPredicate(char *name,struct Snode *list,int number);
void AddPredicate(struct Pnode *pptr);
struct VNode *NewVNode(char *name,int horn);
struct Rnode *NewRule(void);
struct Clause *NewClause(void);
struct CardAtom *NewCardAtom(void);
void PrintVar(FILE *optr,struct VNode *root);
int ApplyRule(struct Rnode *rule,struct Qnode *quantifiers);
void VarInQuant(struct Snode *conditions,struct Qnode *quantifiers, struct Vtemp *rvar);
void itoa(int num,char *buffer);
void Push(struct Snode *sym);
struct Snode *Pop(void);
void EvalPush(int value );
int EvalPop(void);
int StringLog(struct Snode *sptr);
int InData(char *datavalue, struct Pnode *dptr);

int num_pred=0;
int num_data=0;
int num_var=0;
int num_rules=0;
int Nsymbol=0;
int Nconst=0;
int Ncls=0;
int Outcnt;


int DEBUG=0;
int CNF=0;
int OUTFILE=0;

char    **tmplist;
struct VNode *vtmplist[2000];
FILE *ofptr;
struct VNode *Output[2000];
struct Clause *ClauseList[10000000];

int IsSymbol(int c)
{

	if(c>='a'&&c<='z')
        return(1);
	if(c>='A'&&c<='Z')
        return(1);
	if(c>='0'&&c<='9')
        return(1);
    if(c=='_')
        return(1);
    if(ispunct(c))
        return(-1);
	if(isspace(c))
		return(0);
    return(-1);
}

int InKeyW(char *symbol,char **list,int num)
{
	int i;

	for(i=0;i<num;i++)
		if(!strcmp(symbol,list[i]))
			return(i);
	return(-1);
}

void AddQuantifier(struct Qnode *quantifiers,struct Qnode *qptr)
{
	struct Qnode *qtmp;

	if(!strcmp(qptr->qname,"Select")){
			qtmp=quantifiers;
			while(qtmp->next)
				qtmp=qtmp->next;
			qtmp->next=qptr;
	}
	else{
		qtmp=quantifiers;
		if(strcmp(qtmp->qname,"Select")){
			while(qtmp->next &&strcmp(qtmp->next->qname,"Select"))
				qtmp=qtmp->next;
		}
		qptr->next=qtmp->next;
		qtmp->next=qptr;

	}
}

void  SetVarID(struct VNode *root)
{

	if(!root)
		return;
	if(root->value==-1)
		root->vid=++Nsymbol;
	if(root->left!=NULL)
		SetVarID(root->left);
	if(root->right!=NULL)
		SetVarID(root->right);
	return;                                                                       

}

void PrintNeg(FILE *ofptr, struct VNode **list,int cnt)
{
	int i;

	for(i=0;i<cnt;i++)
		fprintf(ofptr," -%i ",list[i]->vid);
}


void PrintList(FILE *ofptr, struct VNode **list,int cnt)
{
	int i;

	for(i=0;i<cnt;i++)
		fprintf(ofptr," %i ",list[i]->vid);
}

void PrintMeta(FILE *ofptr, struct CardAtom **meta, int cnt)
{
	int i;

	for(i=0;i<cnt;i++){
		if(meta[i]->min<0)
			meta[i]->min=0;
		fprintf(ofptr," { %i %i ",meta[i]->min,meta[i]->max);
		PrintList(ofptr,meta[i]->list,meta[i]->ccnt);
		fprintf(ofptr," } ");
	}


}

void PrintCNF(FILE *ofptr)
{
	int i;

	for(i=0;i<Ncls;i++){
		PrintNeg(ofptr,ClauseList[i]->bdy,ClauseList[i]->bdycnt);
		PrintList(ofptr,ClauseList[i]->hd,ClauseList[i]->hdcnt);
		fprintf(ofptr," 0\n");
	}
}

int cntMetaAtoms(void)
{
	int i, tmp=0;

	for(i=0;i<Ncls;i++){
		tmp += ClauseList[i]->metabdycnt+ ClauseList[i]->metahdcnt;
	}
	return tmp;
}

void PrintAspps(FILE *ofptr)
{
	int i;

	for(i=0;i<Ncls;i++){
		PrintList(ofptr,ClauseList[i]->bdy,ClauseList[i]->bdycnt);
		PrintMeta(ofptr,ClauseList[i]->mbdy,ClauseList[i]->metabdycnt);
		if(ClauseList[i]->horn)
			fprintf(ofptr," : ");
		else
			fprintf(ofptr," , ");
		PrintList(ofptr,ClauseList[i]->hd,ClauseList[i]->hdcnt);
		PrintMeta(ofptr,ClauseList[i]->mhd,ClauseList[i]->metahdcnt);
		fprintf(ofptr,"\n");
	}
}


struct VNode *GetVarPtr(char *vsymbol,int horn)
{
	int cmp;
	struct VNode *tmp;

	if(!VTree){
		VTree=NewVNode(vsymbol,horn);
		return(VTree);
	}
	tmp=VTree;
	while((cmp=strcmp(vsymbol,tmp->vsymbol)))
		if(cmp<0){
			if(tmp->left!=NULL)
				tmp=tmp->left;
			else{
				tmp->left=NewVNode(vsymbol,horn);
				return(tmp->left);
			}
		}
		else{
			if(tmp->right!=NULL)
				tmp=tmp->right;
			else{
				tmp->right=NewVNode(vsymbol,horn);
				return(tmp->right);
			}
		}
	return(tmp);
}

int IfInQuant(struct Qnode *qptr, struct Vtemp *rvar)
{
	struct Qnode *qtmp;
	int i;

	qtmp=qptr;
	while(qtmp){
		if(qtmp->qdata){
			for(i=0;i<qtmp->qdata->arity;i++)
				if(rvar==qtmp->qvl[i])
					return(1);
		}
		qtmp=qtmp->next;
	}
	return(0);
}


int IfInCond(struct Snode *cptr, struct Vtemp *rvar)
{

	struct Snode *ltmp;

	ltmp=cptr;
	while(ltmp){
		if(!strcmp(ltmp->symbol,rvar->vname))
			return(1);
		ltmp=ltmp->next;
	}
	return(0);
}

void VarInQuant(struct Snode *conditions,struct Qnode *quantifiers, struct Vtemp *rvar)
{
	struct Qnode *qtmp;

	if(!IfInQuant(quantifiers,rvar)){
		if(!IfInCond(conditions,rvar)){
			qtmp=NewQNode("Forall",rvar->vtype);
			qtmp->qvl[0]=rvar;
			AddQuantifier(quantifiers,qtmp);
		}
	}
}

struct Vtemp *InVarList(char *symbol)
{
	struct Vtemp *tmp;

	tmp=Vlist;
	while(tmp){
		if(!strcmp(symbol,tmp->vname))
			return(tmp);
		tmp=tmp->next;
	}
	return(NULL);
}

struct Pnode *InDataList(char *symbol)
{
	struct Pnode *tmp;

	tmp=Dlist;
	while(tmp){
		if(!strcmp(symbol,tmp->name))
			return(tmp);
		tmp=tmp->next;
	}

	return(NULL);
}

struct Pnode *InPredList(char *symbol)
{
	struct Pnode *tmp;

	tmp=Plist;
	while(tmp){
		if(!strcmp(symbol,tmp->name))
			return(tmp);
		tmp=tmp->next;
	}
	return(NULL);
}

struct Cnode *InConstList(char *symbol)
{
	struct Cnode *tmp;

	tmp=Clist;
	while(tmp){
		if(!strcmp(symbol,tmp->cname))
			return(tmp);
		tmp=tmp->next;
	}
	return(NULL);
}

char *VarName(void)
{
	char  vname[180];
	int i;

	i=0;
	do{
		sprintf(vname,"VT%i",i++);
	} while((InVarList(vname)));

	return(strdup(vname));

}


struct Snode *RemoveMath(struct Snode *conditions,struct Snode *sptr,char *datatype)
{
	struct Snode *stmp,*csptr;
	struct Snode *lptr;
	char *vname;

	vname=VarName();
	NewVarTemp(InDataList(datatype),vname);
	csptr=stmp=sptr->next;
	sptr->next=NewSymbol(vname);
					
	if(DEBUG>2)
		fprintf(stderr,"RemoveMath csptr = %s\n",csptr->symbol);
	if(DEBUG>2)
		fprintf(stderr,"Call ParseLogCond from RemoveMath\n");
	ParseLogCond(csptr);
	lptr=NewSymbol(vname);
	lptr->list=csptr;
	AddCond(conditions,lptr);
	return(sptr->next);
}

struct Clause *SetUpWrite(int horn)
{
	struct Clause *cls;

	cls=NewClause();
	cls->horn=horn;
	Outcnt=0;
	return(cls);
}

int EvaluateCardList(struct CardAtom *ca)
{
	int i;

	i=0;
	while(i<ca->ccnt){
		if(ca->list[i]->value==0)
			ca->list[i]=ca->list[--ca->ccnt];
		else if(ca->list[i]->value==1){
			ca->list[i]=ca->list[--ca->ccnt];
			ca->min--;
			ca->max--;
		}
		else i++;
	}
	if(ca->min<=0&&ca->max>=ca->ccnt)
		return(1);
	if(ca->min>ca->ccnt||ca->max<0)
		return(0);

	return(-1);
}

int EvaluateList(struct VNode **list, int *cnt,int bdy)
{
	int i;

	i=0;
	while(i<(*cnt)){
		if((list[i]->value==0&&bdy)||(list[i]->value==1&&!bdy))
			return(0);
		else if(list[i]->value!=-1){
			list[i]=list[--(*cnt)];
		}
		else i++;
	}
	return(1);
}

int EvaluateCls(struct Clause *cls){

	int i,ret;

	if(!EvaluateList(cls->bdy,&cls->bdycnt,1))
		return(0);
	i=0;
	while(i<cls->metabdycnt){
		ret=EvaluateCardList(cls->mbdy[i]);
		if(ret==0)
			return(0);
		else if(ret==1)
			cls->mbdy[i]=cls->mbdy[--cls->metabdycnt];
		else i++;
	}
	if(!EvaluateList(cls->hd,&cls->hdcnt,0))
		return(0);
	i=0;
	while(i<cls->metahdcnt){
		ret=EvaluateCardList(cls->mhd[i]);
		if(ret==1)
			return(0);
		else if(ret==0)
			cls->mhd[i]=cls->mhd[--cls->metahdcnt];
		else i++;
	}

	return(1);
}


int SetMetaValue(struct CardAtom *meta, int value)
{
	int i;

	if(value){
		if(meta->min<=0&&meta->ccnt<=meta->max)
			return(0);
		else if(meta->min==meta->ccnt&&meta->max==meta->ccnt){
			for(i=0;i<meta->ccnt;i++)
				meta->list[i]->value=1;
			return(0);
		}
		else if(meta->min<=0&&meta->max==0){
			for(i=0;i<meta->ccnt;i++)
				meta->list[i]->value=0;
			return(0);
		}
	}
	else{
		if(meta->min>meta->ccnt||meta->max<0)
			return(0);
		else if(meta->min==1&&meta->ccnt==1){
			meta->list[0]->value=0;
			return(0);
		}
		else if(meta->min==(1+meta->ccnt)&&meta->max==meta->min){
			for(i=0;i<meta->ccnt;i++)
				meta->list[i]->value=1;
			return(0);
		}
	}
	return(1);
}

int Propagate(struct Clause *cls)
{
	if((cls->bdycnt+cls->metabdycnt==1)&&(cls->hdcnt+cls->metahdcnt==0)){
		if(cls->bdycnt&&cls->bdy[0]->value ==-1){
			cls->bdy[0]->value=0;
			return(0);
		}
		else return(SetMetaValue(cls->mbdy[0],0));
	}
	else if((cls->bdycnt+cls->metabdycnt==0)&&(cls->hdcnt+cls->metahdcnt==1)){
		if(cls->hdcnt&&cls->hd[0]->value ==-1){
			if(cls->horn || !cls->hd[0]->horn){
				cls->hd[0]->value=1;
				return(0);
			}
			else return(1);
		}
		else return(SetMetaValue(cls->mhd[0],1));
	}
	return(1);
}

void CompleteWrite(int valid, struct Clause *cls)
{
	int i;

	if(valid){
		if(EvaluateCls(cls)){
			if(Propagate(cls))
				ClauseList[Ncls++]=cls;
			else {
				i=0;
				while(i<Ncls){
					if((EvaluateCls(ClauseList[i])==0)){
						free(ClauseList[i]);
						ClauseList[i]=ClauseList[--Ncls];
					}
					else if(Propagate(ClauseList[i])==0){
						free(ClauseList[i]);
						ClauseList[i]=ClauseList[--Ncls];
						i=0;
					}
					else i++;
				}
			}
		}
		else free(cls);
	}
	else free(cls);
}

int CheckAtom(struct Snode *sptr,int bdy)
{
   struct Pnode *dptr;
   struct Pnode *pptr;
   struct Vtemp *vptr;
   struct Snode *param;
	int ret=1;
   

	if((pptr=InPredList(sptr->symbol))){
		if(bdy==-1&&pptr->horn){
			sprintf(ErrorMessages[NumErrMess++],
					"Horn atom in cardinality atom");
			ret=0;
		}
		else if((dptr=InDataList(pptr->ptype)))
			ret=CheckData(dptr,sptr->next);
		if(ret==1) {
			sptr=sptr->next;
			param=pptr->parameters;
			while(sptr&&ret&&param){
				if((vptr=InVarList(sptr->symbol))){
					if(!vptr->vset) ret=-1;
					else if(!InData(vptr->value,vptr->vtype))
						ret=0;
				}
				else if(!InData(sptr->symbol,InDataList(param->symbol)))
					ret=0;
				sptr=sptr->next;
				param=param->next;
			}
		}
		if(ret) ret=-1;
	}
	else if((dptr=InDataList(sptr->symbol))){
		ret=CheckData(dptr,sptr->next);

	} 
	else if(!strcmp(sptr->symbol,"numerical")){
		ret= Evaluate(sptr->next);
	}
	else if(!strcmp(sptr->symbol,"string")){
		ret= StringLog(sptr->next);
	}
	if(ret==-1) return(1);
	else if ((ret && !bdy)||(bdy&&!ret)) return(0);
	return(1);
}

struct VNode *SetAtomId(struct Snode *sptr,int *ret,int bdy)
{
   char tmpsym[200];
   struct Pnode *dptr;
   struct Pnode *pptr;
   struct Vtemp *vptr;
   struct Snode *param;
	struct VNode *varsym;
   

	(*ret)=-1;
	strcpy(tmpsym,"");
	if((pptr=InPredList(sptr->symbol))){
		if(bdy==-1&&pptr->horn){
			sprintf(ErrorMessages[NumErrMess++],
					"Horn atom in cardinal atom");
			(*ret)=0;
		}
		else if((dptr=InDataList(pptr->ptype)))
			(*ret)=CheckData(dptr,sptr->next);
		else (*ret)=1;
		if((*ret)){
			strcat(tmpsym,sptr->symbol);
			strcat(tmpsym,"(");
			sptr=sptr->next;
			param=pptr->parameters;
			while((*ret)&&sptr&&param){
				if((vptr=InVarList(sptr->symbol))){
					if(vptr->vset&&InData(vptr->value,vptr->vtype))
						strcat(tmpsym,vptr->value);
					else (*ret=0);
				}
				else if(InData(sptr->symbol,InDataList(param->symbol)))
					strcat(tmpsym,sptr->symbol);
				else (*ret)=0;
				if(sptr->next)
					strcat(tmpsym,",");
				else
					strcat(tmpsym,")");
				param=param->next;
				sptr=sptr->next;

			}
			if(DEBUG>2)
				fprintf(stderr,"pptr gd=%i tmpsym = %s bdy = %i\n ",(*ret),tmpsym,bdy);
			if(*ret==1){
				varsym=GetVarPtr(tmpsym,pptr->horn);
				if(((!varsym->value)&&bdy==1)||((varsym->value==1)&&!bdy))
					(*ret)=0;
				else if(((varsym->value==1)&&bdy==1)||((varsym->value==0)&&!bdy))
					(*ret)=-1;
				return(varsym);
			}
			else{
				if(!bdy)
					(*ret)=-1;
				return(NULL);
			}
		}
		if(DEBUG>2)
			fprintf(stderr,"pptr gd=%i tmpsym = %s bdy = %i\n ",(*ret),tmpsym,bdy);
	}
	else if((dptr=InDataList(sptr->symbol))){
		(*ret)=CheckData(dptr,sptr->next);
		if(DEBUG>2)
			fprintf(stderr,"dptr gd=%i sptr->symbol = %s bdy = %i\n ",(*ret),sptr->symbol,bdy);
		if((!bdy&&*ret==1)||(bdy&&*ret==0))
			*ret=0;
		else *ret=-1;
		return( NULL);

	} 
	else if(!strcmp(sptr->symbol,"numerical")){
		(*ret)= Evaluate(sptr->next);
		if(DEBUG>2)
			fprintf(stderr,"gd=%i sptr->symbol = %s bdy = %i\n ",(*ret),sptr->symbol,bdy);
		if((!bdy&&*ret==1)||(bdy&&*ret==0))
			*ret=0;
		else *ret=-1;
		return( NULL);
	}
	else if(!strcmp(sptr->symbol,"string")){
		(*ret)= StringLog(sptr->next);
		if(DEBUG>2)
			fprintf(stderr,"gd=%i sptr->symbol = %s bdy = %i\n ",(*ret),sptr->symbol,bdy);
		if((!bdy&&*ret==1)||(bdy&&*ret==0))
			*ret=0;
		else *ret=-1;
		return( NULL);
	}
	return(NULL);
}

int CheckList(struct Snode *predicates, int bdy)
{
	struct Snode *stmp;

	stmp=predicates;
	while(stmp){
		if(!CheckAtom(stmp,bdy)) return(0);
		stmp=stmp->list;
	}
	return(1);
}

int CheckRule(struct Rnode *rule){
	
	if(rule->body&&!CheckList(rule->body,1)) return(0);
	if(rule->head&&!CheckList(rule->head,0)) return(0);

	return(1);
}

int SetList(struct Snode *predicates, int bdy)
{
	struct Snode *stmp,*sptr;
	int index,cnt=0,inlist,ret;
	struct VNode *varsym;


	stmp=predicates;
	while(stmp){
		sptr=stmp;
		if(DEBUG>2)
			fprintf(stderr,"SetList sptr = %s\n", sptr->symbol);
		varsym=SetAtomId(sptr,&ret,bdy);
		if(!ret) return(0);
		if(ret==1&&varsym){
			inlist=0;
			for(index=0;index<cnt;index++)
				if(Output[index]==varsym)
					inlist=1;
			if(!inlist)
				Output[cnt++]=varsym;
		if(DEBUG>2)
			fprintf(stderr," Varsym= %s ret = %i cnt = %i\n",varsym->vsymbol,ret,cnt);
		}
		stmp=stmp->list;
	}
	if(!cnt) return(-1);
	return(cnt);
}

int SetMetaQ(struct MetaList *ml, struct Qnode *quantifiers,int metacnt)
{
	struct Snode	*data,*pdata;
	int				i,j,*tmpset,valid,inlist,cnt;

	if((tmpset=(int *)malloc(sizeof(int)*quantifiers->qdata->arity))==NULL){
		fprintf(stderr,"Cannot allocate memory: SetMetaQ\n");
		exit(1);
	}
	memset(tmpset,0,sizeof(int)*quantifiers->qdata->arity);
	data=quantifiers->qdata->parameters;
	for(i=0;i<quantifiers->qdata->arity;i++)
		if(quantifiers->qvl[i]->vset==1)
			tmpset[i]=1;
	while(data){
		pdata=data;
		i=0;
		valid=1;
		while(i<quantifiers->qdata->arity&&pdata){
			if(!tmpset[i]){
				strcpy(quantifiers->qvl[i]->value,pdata->symbol);
				quantifiers->qvl[i]->vset=1;
			}
			else if(strcmp(quantifiers->qvl[i]->value,pdata->symbol))
				valid=0;
			i++;
			pdata=pdata->next;
		}
		if(valid){
			if(quantifiers&&quantifiers->next&&quantifiers->next->qdata){
				metacnt=SetMetaQ(ml,quantifiers->next,metacnt);
			}
			else if(SetConditions(ml->conditions)){
					if((cnt=SetList(ml->predicates,-1))>0){
						for(i=0;i<cnt;i++){
							inlist=0;
							for(j=0;j<metacnt;j++)
								if(vtmplist[j]==Output[i])
									inlist=1;
							if(!inlist)
								vtmplist[metacnt++]=Output[i];
							if(DEBUG>2)
								fprintf(stderr," SetMetaQ ; metacnt = %i\n",metacnt);
					   }
				   }
					UnSetConditions(ml->conditions);
					if(!cnt) if(NumErrMess) return(0);
			}
		}
		data=data->list;
	}
	for(i=0;i<quantifiers->qdata->arity;i++)
		quantifiers->qvl[i]->vset=tmpset[i];
	free(tmpset);
	return(metacnt);
}


int WriteMeta(struct MetaAtom *mlist,struct Clause *cls,int bdy)
{
	struct MetaAtom *meta;
	struct MetaList *ml;
	struct CardAtom *ca;
	struct CardAtom **tmp;
	int  metacnt,i,j,k,cnt,inlist;


	meta=mlist;
	metacnt=0;
	while(meta){
		meta=meta->next;
		metacnt++;
	}
	if((tmp=(struct CardAtom **)malloc(sizeof(struct CardAtom *)*metacnt))==NULL){
		fprintf(stderr,"Cannot allocate memory: WriteMeta");
		exit(1);
	}
	memset(tmp,0,sizeof(struct CardAtom *)*metacnt);
	meta=mlist;
	k=0;
	while(meta){
	   ca=NewCardAtom();
	   ca->max=meta->max;
	   ca->min=meta->min;
		ml=meta->metalist;
		metacnt=0;
		while(ml){
			if(ml->quantifiers&&ml->quantifiers->next&&ml->quantifiers->next->qdata){
				metacnt=SetMetaQ(ml,ml->quantifiers->next,metacnt);
			}
			else if(SetConditions(ml->conditions)){
				if((cnt=SetList(ml->predicates,-1))>0){
					for(i=0;i<cnt;i++){
						inlist=0;
						for(j=0;j<metacnt;j++)
							if(vtmplist[j]==Output[i])
								inlist=1;
						if(!inlist)
							vtmplist[metacnt++]=Output[i];
				   }
			   }
				UnSetConditions(ml->conditions);
				if(!cnt) if(NumErrMess) return(0);
			}
			ml=ml->next;
		}
		if((ca->ccnt=metacnt)>0){
		   if((ca->list=(struct VNode **)malloc(sizeof(struct VNode *)*(ca->ccnt)))==NULL){
			   fprintf(stderr,"Cannot allocate memory: MetaQ\n");
			   exit(1);
		   }
		   memcpy(ca->list,vtmplist,sizeof(struct VNode *)*(ca->ccnt));
		}
		if(ca->max==-1)
			ca->max=ca->ccnt;
		meta=meta->next;
		tmp[k++]=ca;
   }
	if(bdy){
		cls->mbdy=tmp;
		cls->metabdycnt=k;
	}
	else{ 
		cls->mhd=tmp;
		cls->metahdcnt=k;
	}
   return(1);
}

int  WriteHead(struct Rnode *rule,struct Clause *cls)
{
	int i,j,tmpcnt,inlist;

   if((tmpcnt=SetList(rule->head,0))>0){
	   for(i=0;i<tmpcnt;i++){
		   inlist=0;
		   for(j=0;j<Outcnt;j++)
			   if(vtmplist[j]==Output[i])
				   inlist=1;
		   if(!inlist)
			   vtmplist[Outcnt++]=Output[i];
	   }
   }
   else if(!tmpcnt)
	   return(0);

	return(1);
}

int  WriteRule(struct Rnode *rule,struct Clause *cls)
{
	int i,tmpcnt,ret;

	ret=1;


   if((tmpcnt=SetList(rule->body,1))>0){
	   cls->bdycnt=tmpcnt;
	   if((cls->bdy=(struct VNode **)malloc(sizeof(struct VNode *)*(cls->bdycnt)))==NULL){
		   fprintf(stderr,"Cannot allocate memory: WriteRule\n");
		   exit(1);
	   }
	   for(i=0;i<cls->bdycnt;i++){
		   cls->bdy[i]=Output[i];
	   }
   }
   else if(!tmpcnt)
	   ret=0;
   Outcnt=0;

   if(ret&&rule->mbdy)
	   if(!WriteMeta(rule->mbdy,cls,1))
		   ret=0;

   Outcnt=0;
   if(ret&&rule->mhd)
	   if(!WriteMeta(rule->mhd,cls,0))
		   ret=0;
   Outcnt=0;
	return(ret);
}

int InData(char *datavalue, struct Pnode *dptr)
{
	struct Snode  *data;

	data=dptr->parameters;
	while(data){
		if(!strcmp(datavalue,data->symbol))
			return(1);
		data=data->list;
	}
	return(0);
}



int CheckData(struct Pnode *dataptr, struct Snode *list)
{
	int arity;
	struct Snode *sptr;
	struct Snode  *ndata,*pdata;
	struct Vtemp *vptr;

	ndata=dataptr->parameters;
	while(ndata){
		sptr=list;
		pdata=ndata;
		arity=dataptr->arity;
		while(pdata&&sptr){
			if((vptr=InVarList(sptr->symbol))){
				if(!vptr->vset) return(-1);
				if(!strcmp(pdata->symbol,vptr->value))
					arity--;
			}
			else if(!strcmp(pdata->symbol,sptr->symbol))
				arity--;
			if(!arity&&!sptr->next) return(1);
			pdata=pdata->next;
			sptr=sptr->next;
		}
		ndata=ndata->list;
	}
	return(0);
}


int DoUnary(int operator, int v1)
{
	switch(operator){
		case 0:
			return(-v1);
			break;
		case 1:
			return(abs(v1));
			break;
		default:
			break;
	}
	return(0);
}

int	DoBinary(int operator,int v1,int v2)
{


	switch(operator){
		case 0:
			return(v1+v2);			
			break;
		case 1:
			return(v1-v2);			
			break;
		case 2:
			return(v1*v2);			
			break;
		case 3:
			return(v1/v2);			
			break;
		case 4:
			while(v1<=0)
				v1+=v2;
			return(v1%v2);
			break;
		case 5:
			if(v1<v2)
				return(v2);
			else return(v1);
			break;
		case 6:
			if(v1>v2)
				return(v2);
			else return(v1);
			break;
		default:
			break;
	}
	return(0);
}

int LogComp(int operator,int ls,int rs)
{

	switch(operator){
		case 0:
			if(ls==rs)
				return(1);
			break;
		case 1:
			if(ls<rs)
				return(1);
			break;
		case 2:
			if(ls>rs)
				return(1);
			break;
		case 3:
			if(ls<=rs)
				return(1);
			break;
		case 4:
			if(ls>=rs)
				return(1);
			break;
		case 5:
			if(ls!=rs)
				return(1);
			break;
		default:
			break;
	}
	
	return(0);
}

int Evaluate(struct Snode *sptr)
{
	struct Snode *stmp;
	struct Vtemp *vptr;
	int leftoperand, rightoperand;
	int op=-1,unary=-1,binary=-1,logic=-1;

	Stkptr=0;
	stmp=sptr;
	while(stmp&&(((op=InKeyW(stmp->symbol,OPTABLE,NUMTABLE))==-1)||PRIORITY[op])){
		if(op==-1){
			if((vptr=InVarList(stmp->symbol))){
				if(!vptr->vset)
					return(-1);
				EvalPush(atoi(vptr->value));
			}
			else
				EvalPush(atoi(stmp->symbol));
		}
		else if((unary=InKeyW(stmp->symbol,UNARY,NUMUNARY))>=0)
			EvalPush(DoUnary(unary,EvalPop()));
		else if((binary=InKeyW(stmp->symbol,BINARY,NUMBIN))>=0){
			rightoperand=EvalPop();
			leftoperand=EvalPop();
			EvalPush(DoBinary(binary,leftoperand,rightoperand));
		}
		else if((logic=InKeyW(stmp->symbol,LOGICOP,NUMLOG))>=0){
			rightoperand=EvalPop();
			leftoperand=EvalPop();
			EvalPush(LogComp(logic,leftoperand,rightoperand));
		}
		if(DEBUG>2){
		fprintf(stderr,"Evaluate: op=%i unary= %i binary=%i logic=%i symbol =  %s",
			op,unary,binary,logic,stmp->symbol);
			if(Stkptr)
			fprintf(stderr," EvalStack[%i] = %i \n", Stkptr-1,EvalStack[Stkptr-1]);
		}

		stmp=stmp->next;
	}
	if(Stkptr!=1){
		sprintf(ErrorMessages[NumErrMess++],
				"Error in math expression Stkptr=%i  ",Stkptr);
		return(0);
	}
	
	return(EvalPop());
}


int CheckVset(struct Snode *sptr)
{
	struct Snode *stmp;
	struct Vtemp *vptr;

	stmp=sptr;
	while(stmp){
		if((vptr=InVarList(stmp->symbol)))
			if(vptr->vtype->arity==1&&!vptr->vset)
				return(0);
		stmp=stmp->next;
	}

	return(1);
}




int CheckNum(char *symbol)
{
	int len,i,j=0;

	len=strlen(symbol);
	if(symbol[0]=='-'||symbol[0]=='+')
		j=1;
	for(i=j;i<len;i++)
		if(symbol[i]<'0'||symbol[i]>'9')
			return(0);
	return(1);
}

int StringComp(int operator, struct Snode *rs, struct Snode *ls)
{

	int cmp;

	cmp=strcmp(ls->symbol,rs->symbol);

	switch(operator){
		case 0:
			if(!cmp)
				return(1);
			break;
		case 1:
			if(cmp<0)
				return(1);
			break;
		case 2:
			if(cmp>0)
				return(1);
			break;
		case 3:
			if(cmp<=0)
				return(1);
			break;
		case 4:
			if(cmp>=0)
				return(1);
			break;
		case 5:
			if(cmp)
				return(1);
			break;
		default:
			break;
	}
	
	return(0);
}

int StringLog(struct Snode *sptr)
{
	struct Snode *stmp;
	struct Vtemp *vptr;
	int logic,ret;

	Stkptr=0;
	stmp=sptr;
	while(stmp){
		if((logic=InKeyW(sptr->symbol,LOGICOP,NUMLOG))>=0){
			ret=StringComp(logic,Pop(),Pop());
			if(ret!=1) return(ret);
		}
		else if((vptr=InVarList(stmp->symbol)))
			Push(NewSymbol(vptr->value));
		else Push(stmp);
		stmp=stmp->next;
	}
	if(Stkptr){
		sprintf(ErrorMessages[NumErrMess++],
				"Error in string compare ");
		return(-1);
	}
	return(ret);
	
}

int CheckLog(struct Rnode *rule)
{

	struct Snode *lptr;
	int ret=1;

	if(rule->logcond){
		lptr=rule->logcond;
		while(lptr){
			if(!strcmp(lptr->symbol,"numerical"))
				ret=Evaluate(lptr->list);
			else
				ret=StringLog(lptr->list);
			if(ret!=1)
				return(ret);
			lptr=lptr->next;
		}
	}
	return(ret);
}
void  SetVarConditions(struct Snode *conditions)
{

	struct Snode *cptr;
	struct Vtemp *vptr;

	if(conditions&&!strcmp(conditions->symbol,"head"))
		cptr=conditions->next;
	else cptr=conditions;
	while(cptr){
		if((vptr=InVarList(cptr->symbol))){
			vptr->vset=1;
			itoa(Evaluate(cptr->list),vptr->value);
		}
		cptr=cptr->next;
	}
}

int SetConditions(struct Snode *conditions)
{

	struct Snode *cptr;
	struct Vtemp *vptr;

	if(conditions&&!strcmp(conditions->symbol,"head"))
		cptr=conditions->next;
	else cptr=conditions;
	while(cptr){
		if(!strcmp(cptr->symbol,"numerical")){
			if(!Evaluate(cptr->list))
				return(0);
		}
		else if(!strcmp(cptr->symbol,"string")){
			if(!StringLog(cptr->list))
				return(0);
		}
		else if((vptr=InVarList(cptr->symbol))==NULL)
			return(0);
		else{
			vptr->vset=1;
			itoa(Evaluate(cptr->list),vptr->value);
			if(!InData(vptr->value,vptr->vtype)){
				vptr->vset=0;
				return(0);
			}
		}
		cptr=cptr->next;
	}
	return(1);
}


int UnSetConditions(struct Snode *conditions)
{

	struct Snode *cptr;
	struct Vtemp *vptr;

	if(conditions&&!strcmp(conditions->symbol,"head"))
		cptr=conditions->next;
	else cptr=conditions;
	while(cptr){
		if((vptr=InVarList(cptr->symbol)))
			vptr->vset=0;
		cptr=cptr->next;
	}
	return(1);
}

void ForAll(struct Rnode *rule,struct Qnode *quantifiers)
{
	struct Clause 	*cls;
	struct Snode	*data,*pdata;
	int 			i,*tmpset,valid,ret;

	if((tmpset=(int *)malloc(sizeof(int)*quantifiers->qdata->arity))==NULL){
		fprintf(stderr,"Cannot allocate memory: Forall\n") ;
		exit(1);
	}
	memset(tmpset,0,sizeof(int)*quantifiers->qdata->arity);
	data=quantifiers->qdata->parameters;
	for(i=0;i<quantifiers->qdata->arity;i++)
		if(quantifiers->qvl[i]->vset==1)
			tmpset[i]=1;
	while(data&&!NumErrMess){
		pdata=data;
		valid=1;
		i=0;
		while(i<quantifiers->qdata->arity&&pdata){
			if(!tmpset[i]){
				strcpy(quantifiers->qvl[i]->value,pdata->symbol);
				quantifiers->qvl[i]->vset=1;
			}
			else if(strcmp(quantifiers->qvl[i]->value,pdata->symbol))
				valid=0;
			i++;
			pdata=pdata->next;
		}
		if(valid){
			if(quantifiers->next){
				if(CheckRule(rule))
					ApplyRule(rule,quantifiers->next);
			}
			else{
				SetVarConditions(rule->conditions);
				cls=SetUpWrite(rule->horn);
				if((ret=WriteRule(rule,cls))){
					if((ret=WriteHead(rule,cls))){
						cls->hdcnt=Outcnt;
						cls->hd=(struct VNode **)malloc(sizeof(struct VNode *)*(Outcnt));
						memcpy(cls->hd,vtmplist,sizeof(struct VNode *)*(Outcnt));
					}
				}
				CompleteWrite(ret,cls);
				UnSetConditions(rule->conditions);
			}
		}
		data=data->list;
	}
	for(i=0;i<quantifiers->qdata->arity;i++)
		quantifiers->qvl[i]->vset=tmpset[i];
	free(tmpset);
}
					

int ChoiceData(struct Rnode *rule,struct Qnode *quantifiers,struct Clause *cls)
{
	struct Snode		*data,*pdata;
	int				wflag,i,*tmpset,valid;

	if((tmpset=(int *)malloc(sizeof(int)*quantifiers->qdata->arity))==NULL){
		fprintf(stderr,"Cannot allocate memory: ChoiceData\n");
		exit(1);
	}
	memset(tmpset,0,sizeof(int)*quantifiers->qdata->arity);
	data=quantifiers->qdata->parameters;
	for(i=0;i<quantifiers->qdata->arity;i++)
		if(quantifiers->qvl[i]->vset==1)
			tmpset[i]=1;
	while(data){
		pdata=data;
		i=0;
		valid=1;
		while(i<quantifiers->qdata->arity&&pdata){
			if(!tmpset[i]){
				strcpy(quantifiers->qvl[i]->value,pdata->symbol);
				quantifiers->qvl[i]->vset=1;
			}
			else if(strcmp(quantifiers->qvl[i]->value,pdata->symbol))
				valid=0;
			i++;
			pdata=pdata->next;
		}
		if(valid){
			if(quantifiers->next&&quantifiers->next->qdata){
				if(!(wflag=ChoiceData(rule,quantifiers->next,cls)))
					data=NULL; 
			}
			else if( SetConditions(rule->conditions)){
				wflag=WriteHead(rule,cls);
				UnSetConditions(rule->conditions);
				if(!wflag) data=NULL; 
			}
		}
		if(data)
			data=data->list;
	}
	for(i=0;i<quantifiers->qdata->arity;i++)
		quantifiers->qvl[i]->vset=tmpset[i];
	free(tmpset);
	return(wflag);
}

void Choice(struct Rnode *rule, struct Qnode *quantifiers)
{
	struct Clause *cls;
	int ret;

	cls=SetUpWrite(rule->horn);
	ret=ChoiceData(rule,quantifiers,cls);
	if(ret){
		cls->hdcnt=Outcnt;
		if((cls->hd=(struct VNode **)malloc(sizeof(struct VNode *)*(Outcnt)))==NULL){
			fprintf(stderr,"Cannot allocate memory:Choice\n");
			exit(1);
		}
		memcpy(cls->hd,vtmplist,sizeof(struct VNode *)*(Outcnt));
	}
	CompleteWrite(ret,cls);
}



int	RangeCompare(char *str1, char *str2)
{
	int  i,len;
	char    tmpstr[180];

	if(isdigit((int)str1[0])){
		len=strlen(str1);
		for(i=0;i<len;i++)
			if(!isdigit((int)str1[i]))
				return(0);
		len=strlen(str2);
		for(i=0;i<len;i++)
			if(!isdigit((int)str2[i]))
				return(0);
		if(atoi(str1)>atoi(str2)){
			strcpy(tmpstr,str1);
			strcpy(str1,str2);
			strcpy(str2,tmpstr);
		}
		return(-1);
	}
	return(0);
}

void	AddToData(struct Pnode *dtmp, char *symbol,int arity)
{
	struct Snode *dataptr;
	int i;

	if(!dtmp->parameters){
		dtmp->parameters=NewSymbol(symbol);
		dtmp->count++;
	}
	else{
		dataptr=dtmp->parameters;
		while(dataptr->list)
			dataptr=dataptr->list;
		if(arity==1){
			dataptr->list=NewSymbol(symbol);
			dtmp->count++;
		}
		else{
			i=1;
			while(i<arity&&dataptr->next)
				dataptr=dataptr->next;
			dataptr->next=NewSymbol(symbol);
		}
	}
}
			


int ParseData(struct Snode *hd,int line)
{
	struct Pnode *dtmp;
	struct Snode *tmp;
	struct Snode *dataptr;
	int inset,indata,inrange,arity,index,newdata;
	char tmpbuffer[80];

	dtmp=NULL;
	tmp=hd;
	inset=indata=inrange=newdata=0;
	while(tmp->next){
		tmp=tmp->next;
		switch(tmp->symbol[0]){
			case LPAREN:
				if(indata || inset)
					sprintf(ErrorMessages[NumErrMess++], 
						"Useage \" %s\" in data predicate",tmp->symbol);
				indata=1;
				arity=1;
				break;
			case RPAREN:
				if(!indata || inset)
					sprintf(ErrorMessages[NumErrMess++], 
						"Useage \" %s\" in data predicate",tmp->symbol);
				indata=0;
				if(newdata)
					dtmp->arity=arity;
				break;
			case '[':
				if(indata || inset)
					sprintf(ErrorMessages[NumErrMess++], 
						"Useage \" %s\" in data predicate",tmp->symbol);
				dtmp->arity=1;
				inset=1;
				break;
			case ']':
				if(inset)
					inset=0;
				else sprintf(ErrorMessages[NumErrMess++], 
						"Useage \" %s\" in data predicate",tmp->symbol);
				break;
			case COMMA:
				if(indata)
					arity++;
				else sprintf(ErrorMessages[NumErrMess++], 
						"Useage \" %s\" in data predicate",tmp->symbol);
				break;
			case '.':
				if(inset)
					inrange=1;
				else sprintf(ErrorMessages[NumErrMess++], "Incorrect set notation in data");
				break;
			default:
				if(!(inset||indata)){
					if(!(dtmp=InDataList(tmp->symbol))){
						newdata=1;
						dtmp=NewData(tmp->symbol);
					}
				}
				else if(dtmp&&indata&&!(inset)){
					AddToData(dtmp,tmp->symbol,arity);
				}
				else if(dtmp&&inset&&!(inrange||indata)){
					AddToData(dtmp,tmp->symbol,1);
				}
				else if(dtmp&&inset&&inrange&&!indata){
					if(!RangeCompare(dtmp->parameters->symbol,tmp->symbol))
						sprintf(ErrorMessages[NumErrMess++], 
							"Invalid Range \" %s\" in data predicate",tmp->symbol);
					else{
						index=atoi(dtmp->parameters->symbol)+1;
						dataptr=dtmp->parameters;
						while(index<= atoi(tmp->symbol)){
							sprintf(tmpbuffer,"%i",index);
							dataptr->list=NewSymbol(tmpbuffer);
							dataptr=dataptr->list;
							dtmp->count++;
							index++;
						}
					}
				}
				else sprintf(ErrorMessages[NumErrMess++], 
						"Reading data \" %s\" ",tmp->symbol);
		}
	}
	return(1);
}
		

char *ParseConstant(char *constant)
{
	int i;
	char line[180];

	i=0;
	while(constant[i]!='='){
		line[i]=constant[i];
		i++;
	}
	line[i]='\0';
	NewConst(line,&constant[i+1]);
	return(&constant[i+1]);
}



int ParseVar(struct Snode *hd)
{
	struct	Snode *tmp;
	struct 	Pnode *dptr;
	int ret=0;

	
	tmp=hd->next;
	if(tmp&&(dptr=InDataList(tmp->symbol))){
		tmp=tmp->next;
		while(tmp){
			if(IsSymbol(tmp->symbol[0])==1){
				ret=1;
				NewVarTemp(dptr,tmp->symbol);
			}
			else if(tmp->symbol[0]!=COMMA)
				return(0);
			tmp=tmp->next;
		}
	}
	hd->next=NULL;
	return(ret);
}
		

int	CheckOp(char token)
{
	int i;

	for(i=0;i<NUMFIRST;i++)
		if(token==FIRSTPOS[i][0])
			return(i);
	return(-1);
}

void AddCond(struct Snode *conditions, struct Snode *cptr)
{
	struct Snode *ctmp;

	if(cptr){
		if(conditions){
			ctmp=conditions;
			while(ctmp->next)
				ctmp=ctmp->next;
			ctmp->next=cptr;
			/*
			while(ctmp->next&&strcmp(ctmp->symbol,"string")&&strcmp(ctmp->symbol,"numerical"))
				ctmp=ctmp->next;
			cptr->next=ctmp->next;
			ctmp->next=cptr;
			*/
		}
		else conditions=cptr;
	}
}

struct Snode *ParseLogCond(struct Snode *slist)
{
	struct Snode *hd,*stmp,*prev,*sptr;
	struct Vtemp *vptr;
	int  more,op,prior,nonnumerical=0,numerical=1;;

	Stkptr=0;
	hd=NewSymbol("string");
	/*
	hd->next=slist->next;
	slist->next=hd; 
	*/
	hd->next=slist;
	sptr=hd->next;
	prev=hd;
	while(sptr&&(((op=InKeyW(sptr->symbol,OPTABLE,NUMTABLE))==-1)||PRIORITY[op])){
		if(sptr->symbol[0]==LPAREN){
			prev->next=sptr->next;
			Push(sptr);
			sptr=prev;
		}
		else if(sptr->symbol[0]==RPAREN){
			while((stmp=Pop())&&stmp->symbol[0]!=LPAREN){
				prev->next=stmp;
				prev=prev->next;
			}
			prev->next=sptr->next;
			free(sptr);
			sptr=prev;
			free(stmp);
		}
		else if((op=InKeyW(sptr->symbol,OPTABLE,NUMTABLE))>=0){
			more=1;
			while(Stkptr&&more){
				stmp=Pop();
				if((stmp->symbol[0]==LPAREN)||
					(((prior=InKeyW(stmp->symbol,OPTABLE,NUMTABLE))!=-1)&&
					((PRIORITY[prior]<PRIORITY[op])|| ((PRIORITY[prior]==PRIORITY[op])&&
					PRIORITY[op]==MAXPRIORITY)))){
					Push(stmp);
					more=0;
				}
				else{
					prev->next=stmp;
					prev=prev->next;
				}
			}
			prev->next=sptr->next;
			Push(sptr);
			sptr=prev;
		}
		else if((vptr=InVarList(sptr->symbol))){
			if(CheckNum(vptr->vtype->parameters->symbol))
				numerical=1;
		}else if(CheckNum(sptr->symbol))
				numerical=1;
		else nonnumerical=1;
		prev=sptr;
		sptr=sptr->next;
	}
	while(Stkptr){
		prev->next=Pop();
		prev=prev->next;
	}
	if(numerical&&!nonnumerical)
		strcpy(hd->symbol,"numerical");
	else if(numerical&&nonnumerical)
		sprintf(ErrorMessages[NumErrMess++],
			"Error in expression ");
	return(hd);

}


struct Snode *ParseFunction(struct Snode *symbols)
{
	struct Snode *stmp,*binptr,*prev;
	int binop=0,depth=0,op;

	stmp=symbols;
	while(stmp->next){
		prev=stmp;
		stmp=stmp->next;
		if(stmp->symbol[0]==LPAREN)
			depth++;
		else if(stmp->symbol[0]==RPAREN){
			depth--;
			if(!depth)
				return(symbols);
		}
		else if(InKeyW(stmp->symbol,BINARY,NUMBIN)>3){
			binptr=stmp;	
			prev->next=stmp->next;
			stmp=prev;
			binop=1;
		}
		else if(stmp->symbol[0]==COMMA){
			if(binop){
				binptr->next= NewSymbol("(");
				prev->next=NewSymbol(")");
				prev=prev->next;
				prev->next=binptr;
				binptr->next->next=stmp->next;
				prev=binptr;
				stmp=prev->next;
			}
			else return(symbols);
		}
		else if(((op=InKeyW(stmp->symbol,OPTABLE,NUMTABLE))!=-1)&&(PRIORITY[op]==0)){
			return(symbols);
		}
	}
	return(symbols);
}


struct Snode *CheckPredicate(struct Snode *conditions,struct Qnode *quantifiers,struct Pnode *pptr,struct Snode *symbols,int bdy,int data )
{
	int sym=0,depth=0,math=0,logic=0,funct=0,key;
	struct Snode *optr=NULL,*param=NULL,*stmp=NULL,*prev=NULL;
	struct Vtemp *vptr=NULL;
	struct Qnode *qptr=NULL;
	struct Pnode *dptr=NULL;
	char buffer[10];


	if(bdy==1)
		strcpy(buffer,"Forall");
	else
		strcpy(buffer,"Select");
	param=pptr->parameters;
	stmp=symbols->next;
	prev=symbols;
	while(stmp){
		if(stmp->symbol[0]==RPAREN){
			if(depth==1){
				prev->next=NULL;
				if(!sym)
					 sprintf(ErrorMessages[NumErrMess++],
						" Incorrect Parameter in \"%s\"", pptr->name);
				else{
				   	if(funct)
						ParseFunction(optr);
				   	if(math)
						RemoveMath(conditions,optr,param->symbol);	
				}
				if(stmp->next&&stmp->next->symbol[0]==':'){
					SetMetaConditions(conditions,quantifiers,stmp->next,bdy);
				}
				return(symbols);
			}
			depth--;
		}
		else if(stmp->symbol[0]==','){
			if(!funct||depth==1){
				prev->next=NULL;
				if(!sym||!param->next)
					 sprintf(ErrorMessages[NumErrMess++],
						" Incorrect Parameter in \"%s\"", pptr->name);
				else{
					if(funct)
						prev=ParseFunction(optr);
					if(math)
						prev=RemoveMath(conditions,optr,param->symbol);	
				}
				param=param->next;
				prev->next=stmp->next;
				stmp=prev;
				logic=sym=math=funct=0;
				optr=stmp;
			}
		}
		else if(stmp->symbol[0]==LPAREN){
			if(!optr){
				prev->next=stmp->next;
				stmp=prev;
				optr=stmp;
			}
			depth++;
		}
		else if((key=InKeyW(stmp->symbol,MATHOP,NUMMATH))!=-1){
			 math=1;
			 if(key>3)
				funct=1;
		}
		else if(!strcmp(stmp->symbol,"_")){
			if((dptr=InDataList(param->symbol))){
				optr=NewSymbol(VarName());
				vptr=NewVarTemp(dptr,optr->symbol);
				qptr=NewQNode("Select",vptr->vtype);
				qptr->qvl[0]=vptr;
				AddQuantifier(quantifiers,qptr);
				prev->next=optr;
				optr->next=stmp->next;
				stmp=optr;
				sym++;
			}
		}
		else if((vptr=InVarList(stmp->symbol))){
			sym++;
			if(!optr) optr=stmp;
			if(!data&&strcmp(param->symbol,vptr->vtype->name))
				sprintf(ErrorMessages[NumErrMess++],
				"Incorrect parameter type for %s" ,pptr->name);
		}
		else {
			if(!optr) optr=stmp;
			sym++;
		}
		if(!stmp->next&&sym){
			if(funct)
				ParseFunction(optr);
			if(math)
				RemoveMath(conditions,optr,param->symbol);	
			return(symbols);
		}
		prev=stmp;
		stmp=stmp->next;
	}
	if(depth)
		sprintf(ErrorMessages[NumErrMess++],"Mismatched ()'s");
	return(symbols);
}

int RuleType(struct Snode *symbols,int *horn)
{
	struct Snode  *stmp;
	int		ret=0,num=0,depth=0,braces=0;

	stmp=symbols;
	while(stmp->next){
		stmp=stmp->next;
		if(stmp->symbol[0]=='(') depth++;
		else if(stmp->symbol[0]==')'){
			depth--;
			if(depth<0)
					sprintf(ErrorMessages[NumErrMess++],
					"Rule has mismatched parentheses");
		}
		else if(stmp->symbol[0]=='{')braces++;
		else if(stmp->symbol[0]=='}'){
			braces--;
			if(braces<0)
					sprintf(ErrorMessages[NumErrMess++],
					"Rule has mismatched curly braces");
		}
		else if(!strcmp(stmp->symbol,"->")){
			if(num)
				sprintf(ErrorMessages[NumErrMess++],
				"Rule has multiple implication symbols");
			if(depth)
				 sprintf(ErrorMessages[NumErrMess++],
						"Rule has incorrect use of parentheses");
			if(braces)
				 sprintf(ErrorMessages[NumErrMess++],
						"Rule has incorrect use of curly braces");
			ret=1;
			num++;
		}
		else if(!strcmp(stmp->symbol,":-")){
			if(num)
				sprintf(ErrorMessages[NumErrMess++],
				"Rule has multiple implication symbols");
			if(depth)
				 sprintf(ErrorMessages[NumErrMess++],
						"Rule has incorrect use of parentheses");
			if(braces)
				 sprintf(ErrorMessages[NumErrMess++],
						"Rule has incorrect use of curly braces");
			*horn=1;
			num++;
		}
		else if(depth){
			if(InPredList(stmp->symbol)||InDataList(stmp->symbol)||
				(InKeyW(stmp->symbol,LOGICOP,NUMLOG)!=-1))
					 sprintf(ErrorMessages[NumErrMess++],
					"Rule has incorrect use of parentheses");
		}
	}
	if(*horn && CNF) sprintf(ErrorMessages[NumErrMess++],
			"Cannot have Horn clause in CNF format" );
	if(depth) sprintf(ErrorMessages[NumErrMess++],
			"Rule has mismatched parentheses");
	if(braces) sprintf(ErrorMessages[NumErrMess++],
			"Rule has mismatched curly braces");

	return(ret);
}

void SetQuantifiers(struct Qnode *quantifiers, struct Snode *sptr, struct Pnode  *dtype)
{
	struct Qnode *qptr;
	struct Snode *stmp;
	struct Vtemp *vptr;
	int i,cflag=0;

		qptr=NewQNode("Forall",dtype);
		i=0; stmp=sptr;
		while(stmp&&!cflag){
			if((vptr=InVarList(stmp->symbol)))
				qptr->qvl[i++]=vptr;
			else cflag=1;
			stmp=stmp->next;
		}
		if(cflag) free(qptr);
		else
			AddQuantifier(quantifiers,qptr);
}


void SetMetaConditions(struct Snode *conditions,struct Qnode *quantifiers,struct Snode *sptr, int bdy)
{
	struct Snode *lptr,*stmp;
	struct Pnode *dptr;

	if((dptr=InDataList(sptr->symbol))){
		sptr=CheckPredicate(conditions,quantifiers,dptr,sptr,bdy,1);
		SetQuantifiers(quantifiers,sptr->next,dptr);
	}
	else {
		stmp= ParseLogCond(sptr);	
		lptr=NewSymbol(stmp->symbol);	
		lptr->list=stmp->next;
		AddCond(conditions,lptr);
	}
}


void ParseMeta(struct Rnode *rule, struct Snode *sptr,int bdy)
{
	struct Snode *stmp,*prev,*optr;
	struct MetaAtom *meta;
	struct MetaList *ml;
	struct Pnode *pptr;
	int state=0;

	meta=NewMetaAtom();
	stmp=sptr;
	if(stmp->symbol[0]!='{'){
		meta->min = atoi(stmp->symbol);
		stmp=stmp->next;
	}
	ml=meta->metalist=NewMetaList();
	optr=stmp->next;
	while(stmp->next){
		prev=stmp;
		stmp=stmp->next;
		if(stmp->symbol[0]==':' || stmp->symbol[0]=='}'||stmp->symbol[0]==';'){
			prev->next=NULL;
			if((pptr=InPredList(optr->symbol))&&!state){
				CheckPredicate(ml->conditions,ml->quantifiers,pptr,optr,-1,0);
				ml->predicates=optr;
			}
			else if(state==1)
				SetMetaConditions(ml->conditions,ml->quantifiers,optr,-1);
			if(stmp->symbol[0]==':') state=1;
			else if(stmp->symbol[0]==';'){
				ml->next=NewMetaList();
				ml=ml->next;
				state=0;
			}
			else if(stmp->symbol[0]=='}'){
				if( stmp->next)
					meta->max=atoi(stmp->next->symbol); 
			}
			optr=stmp->next;
		}
	}
	if(bdy){
		if(rule->mbdy)
			meta->next=rule->mbdy;
		rule->mbdy=meta;
	}
	else{
		if(rule->mhd)
			meta->next=rule->mhd;
		rule->mhd=meta;
	}
}

void ListQuantifier(struct Rnode *rule, struct Snode *slist)
{
	struct Snode *stmp,*ltmp;
	struct Vtemp *vptr;

	ltmp=slist;
	while(ltmp){
		stmp=ltmp;
		while(stmp){
			if((vptr=InVarList(stmp->symbol)))
				VarInQuant(rule->conditions,rule->quantifiers,vptr);
			stmp=stmp->next;
		}
		ltmp=ltmp->list;
	}
}

void ListMeta(struct Rnode *rule, struct MetaList *ml,struct Snode *slist)
{
	struct Snode *stmp;
	struct Vtemp *vptr;

	stmp=slist;
	while(stmp){
		if((vptr=InVarList(stmp->symbol)))
			if(!IfInQuant(ml->quantifiers,vptr)&&!IfInCond(ml->conditions,vptr))
				VarInQuant(rule->conditions,rule->quantifiers,vptr);
		stmp=stmp->next;
	}
}

void CheckMeta(struct Rnode *rule,struct MetaAtom *mptr)
{
	struct Snode *cptr;
	struct MetaAtom *tptr;
	struct MetaList *ml;

	tptr=mptr;
	while(tptr){
		ml=tptr->metalist;
		while(ml){
			ListMeta(rule,ml,ml->predicates);
			cptr=ml->conditions;
			while(cptr){
				ListMeta(rule,ml,cptr->list);
				cptr=cptr->next;
			}
			ml=ml->next;
		}
		tptr=tptr->next;
	}
}


void CheckQuantifiers(struct Rnode *rule)
{
	struct Snode *stmp;
	struct Snode *lptr;
	struct Vtemp *vptr;

	ListQuantifier(rule,rule->body);
	ListQuantifier(rule,rule->head);
	if(rule->conditions){
		lptr=rule->conditions;
		while(lptr){
			stmp=lptr->list;
			while(stmp){
				if((vptr=InVarList(stmp->symbol)))
					if(strcmp(lptr->symbol,vptr->vname))
						VarInQuant(rule->conditions,rule->quantifiers,vptr);
				stmp=stmp->next;
			}
			lptr=lptr->next;
		}
	}
	CheckMeta(rule,rule->mbdy);
	CheckMeta(rule,rule->mhd);
	
}

struct Snode * AddToList(struct Snode *rlist, struct Snode *pred, int priority,int parity)
{
	struct Snode *tmp,*prev;
	struct Pnode *dptr;
	int done=0;

	if((!priority&&(!(dptr=InDataList(rlist->symbol))||dptr->arity< parity))
		||(priority==1&&InPredList(rlist->symbol))){
		pred->list=rlist;
		return(pred);
	}
	prev=rlist;
	tmp=rlist->list;
	while(!done&&tmp){
		if((priority==2)
			||((priority==1&&(InDataList(tmp->symbol)))
			||!strcmp(tmp->symbol,"numerical"))
			||(!priority&&((dptr=InDataList(tmp->symbol))&&dptr->arity> parity))){
			prev=tmp;
			tmp=tmp->list;
		}
		else
			done=1;
	}
	pred->list=tmp;
	prev->list=pred;
	return(rlist);
}

void AddPredToRule(struct Rnode *rule, struct Snode *stmp, int bdy,int priority,int parity)
{
	if(bdy){
		if(!rule->body)
			rule->body=stmp;
		else
			rule->body=AddToList(rule->body,stmp,priority,parity);
	}
	else if(!rule->head){
		rule->head =stmp;
	}
	else 
		rule->head=AddToList(rule->head,stmp,priority,parity);
}

void ParseRulePredicates(struct Rnode *rule, struct Snode *stmp, int bdy)
{
	struct Pnode *pptr;
	struct Pnode *dptr;
	struct Snode *sptr;

	if((pptr=InPredList(stmp->symbol))){
		if(rule->horn&&!bdy)
			pptr->horn=1;
		stmp=CheckPredicate(rule->conditions,rule->quantifiers,pptr,stmp,bdy,0);
		if(bdy&&(dptr=InDataList(pptr->ptype)))
			SetQuantifiers(rule->quantifiers,stmp->next,dptr);
		AddPredToRule(rule,stmp,bdy,2,pptr->arity);
		if(bdy)rule->bdycnt++;
		else rule->hdcnt++;
	}
	else if((dptr=InDataList(stmp->symbol))){
		if(rule->horn&&!bdy)
			sprintf(ErrorMessages[NumErrMess++],
			"Rule %i Data predicate \"%s\" is invalid in head of Horn clause",
			rule->rid,stmp->symbol);
		stmp=CheckPredicate(rule->conditions,rule->quantifiers,dptr,stmp,bdy,1);
		if(bdy)
			SetQuantifiers(rule->quantifiers,stmp->next,dptr);
		else
			AddPredToRule(rule,stmp,bdy,0,dptr->arity);
	}	
	else if(stmp->symbol[0]=='{'||stmp->next->symbol[0]=='{'){
		if(CNF)
			sprintf(ErrorMessages[NumErrMess++],
			"Rule %i Cardinality atom is invalid in CNF format",
			rule->rid);
		ParseMeta(rule,stmp,bdy);
	}
	else{ 
		ParseFunction(stmp);
		sptr=ParseLogCond(stmp);
		AddPredToRule(rule,sptr,bdy,1,2);
	}
}



int Expression(struct Snode *symbols)
{
	int bdy,sym,depth=0;
	struct  Snode *prev,*stmp,*ptmp;
	struct	Rnode *rule;

	rule=NewRule();
	bdy=RuleType(symbols,&rule->horn);
	
	stmp=symbols;
	ptmp=stmp->next;
	while(stmp&&stmp->next){
		if(NumErrMess) return(0);
		prev=stmp;
		stmp=stmp->next;
		if((stmp->symbol[0]==LPAREN)|| (stmp->symbol[0]=='{'))
			depth++;
		else if((stmp->symbol[0]==RPAREN)|| (stmp->symbol[0]=='}'))
			depth--;
		if(!depth){
			if((((sym= InKeyW(stmp->symbol, OPTABLE, NUMOP))!=-1) &&sym<4)
					||!stmp->next){
				if(ptmp!=stmp){
					if(sym>=0&&sym<4)
						prev->next=NULL;
					ParseRulePredicates(rule,ptmp,bdy);
					ptmp=stmp->next;
				}
				if(sym==0)
					bdy=0;
				else if((sym==1&&!bdy)||(sym==2&&(bdy||rule->horn))){
					sprintf(ErrorMessages[NumErrMess++],
					"Rule %i Symbol \"%s\" is invalid in head of clause ",
					rule->rid,stmp->symbol);
				}
				else if(sym==3){
					if(rule->mhd)
						sprintf(ErrorMessages[NumErrMess++],
				"Rule %i -- Cannot have cardinality atom in head of Horn clause", 
					rule->rid);
					bdy=1;
				}
			}
		}
	}
	CheckQuantifiers(rule);
	AddRuleToList(rule);
	return(1);
}

int ApplyRule(struct Rnode *rule, struct Qnode *quantifier)
{
	if(DEBUG>2)
		fprintf(stderr,"ApplyRule quantifier = %s\n",quantifier->qname);
	
	if(quantifier&&quantifier->qdata){
		if(!strcmp(quantifier->qname,"Forall"))
			ForAll(rule,quantifier);
		else Choice(rule,quantifier);
	}

	return(1);
}

int Instantiate(void)
{
	struct Rnode *rptr;
	struct Clause *cls;
	int ret;
	struct tms cpu;
	double begin, cputime;

	times(&cpu);
	begin=cpu.tms_utime;
	rptr=Rlist;
	while(rptr&&!NumErrMess){
		if(rptr->quantifiers->next)
			ApplyRule(rptr,rptr->quantifiers->next);
		else{ 
			SetVarConditions(rptr->conditions);
			cls=SetUpWrite(rptr->horn);
			if((ret=WriteRule(rptr,cls))){
				if((ret=WriteHead(rptr,cls))){
					cls->hdcnt=Outcnt;
					if((cls->hd=(struct VNode **)malloc(sizeof(struct VNode *)*(Outcnt)))==NULL){
						fprintf(stderr,"Cannot allocate memory: Instantiate\n");
						exit(1);
					}
					memcpy(cls->hd,vtmplist,sizeof(struct VNode *)*(Outcnt));
				}
			}
			CompleteWrite(ret,cls);
			UnSetConditions(rptr->conditions);
		}
		if(DEBUG){
			times(&cpu);
			cputime=(cpu.tms_utime-begin)/CLK_TCK;
			begin=cpu.tms_utime;
			fprintf(stderr,"Instantiate Rule id = %i Time = %g\n",rptr->rid,cputime);
		}
		rptr=rptr->next;
	}
	if(NumErrMess) return(0);
	return(1);
}

void AddToSnode(struct Snode *lptr,char *symbol)
{
	struct Snode *sptr;

	if(lptr->list){
		sptr=lptr->list;
		while(sptr->next)
			sptr=sptr->next;
		sptr->next=NewSymbol(symbol);
	}
	else 
		lptr->list=NewSymbol(symbol);
}


void itoa(int num,char *buffer)
{
	int i,j,c,len,neg=0;

	if(num<0){
		neg=1;
		num=-num;
	}
	i=0;
	do{
		buffer[i++]=num % 10 +'0';
	}
	while((num/=10));
	if(neg) buffer[i++]='-';
	buffer[i]='\0';
	len=i-1;
	for(i=0,j=len;i<j;i++,j--){
		c=buffer[i];
		buffer[i]=buffer[j];
		buffer[j]=c;
	}
}


int ParseIDBPred(struct Snode *hd)
{
	struct	Snode *tmp,*prev;
	int ret=0,settype=0;
	char ptype[NAMELEN];

	
	tmp=hd->next->next;
	while(tmp->next){
		prev=tmp;
		tmp=tmp->next;
		if(IsSymbol(tmp->symbol[0])==1){
			if(InDataList(tmp->symbol)){
				if(settype){
					strcpy(ptype,tmp->symbol);
					prev->next=tmp->next;
					free(tmp);
					tmp=prev;
				}
				else
					ret++;
			}
			else return(-1);
		}
		else{
			if(tmp->symbol[0]==':')
				settype=1;
			else if(tmp->symbol[0]!=LPAREN&& tmp->symbol[0]!=RPAREN&& tmp->symbol[0]!=COMMA)
				return(-1);
			prev->next=tmp->next;
			free(tmp);
			tmp=prev;
		}
	}
	tmp=hd->next->next;
	AddPredicate(NewPredicate(tmp->symbol,tmp->next,ret));
	if(settype)
		strcpy(Plist->ptype,ptype);
	free(tmp);
	hd->next=NULL;
	return(ret);
}


struct Snode *Tokenize(char *buffer,int length)
{
	struct  Cnode *cptr;
	struct	Snode *hptr,*tptr;
	char    token[1000];
	int		index=0, sym,i;

	tptr=hptr=NewSymbol("head");
	i=0;
	while(index<length){
		sym=IsSymbol(buffer[index]);
		if(sym==1)
			token[i++]=buffer[index];
		else{
			if(i){
				token[i]=EOS;
				i=0;
				if((cptr=InConstList(token)))
					tptr->next=NewSymbol(cptr->value);
				else
					tptr->next=NewSymbol(token);
				tptr=tptr->next;
			}
			if(sym==-1){
				if((index+1<length)&&((buffer[index]=='!'&&buffer[index+1]=='=')||
					(buffer[index]==':'&&buffer[index+1]=='-')||
					(buffer[index]=='.'&&buffer[index+1]=='.')||
					(buffer[index]=='<'&&buffer[index+1]=='=')||
					(buffer[index]=='>'&&buffer[index+1]=='=')||
					(buffer[index]=='='&&buffer[index+1]=='=')||
					(buffer[index]=='-'&&buffer[index+1]=='>'))){
					token[i++]=buffer[index++];
					token[i++]=buffer[index];
				}
				else token[i++]=buffer[index];
				token[i]=EOS;
				tptr->next=NewSymbol(token);
				tptr=tptr->next;
				i=0;
			}
		}
		index++;
	}
	if(i){
		token[i]=EOS;
		if((cptr=InConstList(token)))
			tptr->next=NewSymbol(cptr->value);
		else
			tptr->next=NewSymbol(token);
	}
	return(hptr);
}

void ParseSymbols(struct Snode *hptr,int dfile,int line)
{
	if(dfile)
		ParseData(hptr,line);
	else if(!strcmp("pred",hptr->next->symbol)){
		if((ParseIDBPred(hptr))<0)
			sprintf(ErrorMessages[NumErrMess++],
			"Syntax Error: line %i",line);
	}
	else if(!strcmp("var",hptr->next->symbol)){
		if(!(ParseVar(hptr->next)))
			sprintf(ErrorMessages[NumErrMess++],
			"Syntax Error: line %i",line);
	}
	else if(!Plist)
		sprintf(ErrorMessages[NumErrMess++],
		"No predicates before rule %s",hptr->next->symbol);
	else if(!Vlist)
		sprintf(ErrorMessages[NumErrMess++],
		"No variables before rule %s",hptr->next->symbol);
	else
		Expression(hptr);
}


int ReadFile(char *rfilename,int dfile)
{
	struct	Snode *hptr=NULL;
	char    rbuffer[1000];
	int		line=1,pos=0,index,comment=0, ch,i;
	FILE    *rfptr;

	if(DEBUG){
		if(dfile)
			fprintf(stderr,"Reading data file ... %s\n",rfilename);
		else
			fprintf(stderr,"Reading rule file ... %s\n",rfilename);
	}
	if((rfptr=fopen(rfilename,"r"))==NULL){
		printf("Error: can not open  %s \n",rfilename);
		return(1);
	}
	index=0;
	while((ch=fgetc(rfptr))!=EOF){
		pos++;
		if(ch=='%')
			comment=1;
		else if(ch=='\n'){
			comment=0;
			line++;
			pos=0;
		}
		else if(!comment){
			if(ch=='.'){
				if((ch=fgetc(rfptr))=='.'){
					rbuffer[index++]=ch;
					rbuffer[index++]=ch;
				}
				else{
					ungetc(ch,rfptr);
					hptr=Tokenize(rbuffer,index);
					ParseSymbols(hptr,dfile,line);
					hptr=NULL;
					index=0;
				}
			}
			else rbuffer[index++]=ch; 
		}
	}
				
	fclose(rfptr);
	comment=0;
	for(i=0;i<index;i++)
		if(IsSymbol(rbuffer[i]))
			comment=1;
	if(comment)
		sprintf(ErrorMessages[NumErrMess++],
			"Reached end of file ");

	return(1);
}

int ErrorMessage(void)
{

	int i;

	for(i=0;i<NumErrMess;i++)
		fprintf(stderr,"COMPILE ERROR: %s \n",ErrorMessages[i]);

	return(NumErrMess);

}

void DebugMeta(struct MetaAtom *ma, char *place)
{
	int i;
	struct MetaAtom *meta;
	struct	Snode	*stmp;
	struct  Snode	*cptr;
	struct  Qnode	*qtmp;
	struct  MetaList	*ml;

	meta=ma;
	while(meta){
		ml=meta->metalist;
		while(ml){
			fprintf(stderr,"Meta atom in  %s -- ",place);
			stmp=ml->predicates;
			while(stmp){
				fprintf(stderr," %s  ",stmp->symbol);
				stmp=stmp->next;
			}
			fprintf(stderr,"Meta conditons -- ");
			cptr=ml->conditions;
			while(cptr){
				stmp=cptr->list;
				fprintf(stderr," %s  ",cptr->symbol);
				while(stmp){
					fprintf(stderr," %s  ",stmp->symbol);
					stmp=stmp->next;
				}
				cptr=cptr->next;
			}
			fprintf(stderr,"Meta quantifiers -- ");
			qtmp=ml->quantifiers;
			while(qtmp){
				fprintf(stderr,"qname %s -- ",qtmp->qname);
				if(qtmp->qdata){
					fprintf(stderr," %s -- ",qtmp->qdata->name);
					for(i=0;i<qtmp->qdata->arity;i++)
						fprintf(stderr," %s ",qtmp->qvl[i]->vname);
				}
				fprintf(stderr,"\n");
				qtmp=qtmp->next;
			}
			ml=ml->next;
		}
		meta=meta->next;
	}
	fprintf(stderr,"\n");
}

void DebugInfo(int data)
{
	struct	Pnode	*tmp;
	struct	Snode	*vtmp,*dtmp;
	struct	Pnode	*ptmp;
	struct	Snode	*stmp;
	struct  Vtemp	*Vtmp;
	struct  Rnode	*rtmp;
	struct  Snode	*cptr;
	struct  Qnode	*qtmp;
	struct  Snode	*lptr;
	int i;

	if(data){
		tmp=Dlist;
		while(tmp){
			fprintf(stderr,"%s :arity=%i count=%i\n",tmp->name,tmp->arity,tmp->count);
			dtmp=tmp->parameters;
			while(dtmp){
				vtmp=dtmp;
				while(vtmp){
					fprintf(stderr,"%s ",vtmp->symbol);	
					vtmp=vtmp->next;
				}
				fprintf(stderr,"\n");	
				dtmp=dtmp->list;
			}
			tmp=tmp->next;
		}
	}
	else {
		ptmp=Plist;
		while(ptmp){
			fprintf(stderr,"%s : arity=%i \n",ptmp->name,ptmp->arity);
			stmp=ptmp->parameters;
			while(stmp){
				fprintf(stderr,"%s ",stmp->symbol);	
				stmp=stmp->next;
			}
			fprintf(stderr,"\n");	
			ptmp=ptmp->next;
		}
		Vtmp=Vlist;
		while(Vtmp){
			fprintf(stderr,"type %s :name %s  arity=%i \n",
				Vtmp->vtype->name,Vtmp->vname,Vtmp->vtype->arity);
			Vtmp=Vtmp->next;
		}
		rtmp=Rlist;
		while(rtmp){
			fprintf(stderr,"id=%i \n", rtmp->rid);
			qtmp=rtmp->quantifiers;
			while(qtmp){
				fprintf(stderr,"qname %s -- ",qtmp->qname);
				if(qtmp->qdata){
					fprintf(stderr," %s -- ",qtmp->qdata->name);
					for(i=0;i<qtmp->qdata->arity;i++)
						fprintf(stderr," %s ",qtmp->qvl[i]->vname);
				}
				fprintf(stderr,"\n");
				qtmp=qtmp->next;
			}
			cptr=rtmp->conditions;
			while(cptr){
				fprintf(stderr,"conditions type %s \n",cptr->symbol);
				stmp=cptr->list;
				fprintf(stderr,"condition symbols ");
				while(stmp){
					fprintf(stderr,"%s  ",stmp->symbol);
					stmp=stmp->next;
				}
				cptr=cptr->next;
				fprintf(stderr,"\n");
			}
			lptr=rtmp->logcond;
			while(lptr){
				stmp=lptr->list;
				fprintf(stderr,"logic symbols ");
				while(stmp){
					fprintf(stderr," %s  ",stmp->symbol);
					stmp=stmp->next;
				}
				fprintf(stderr,"\n");
				lptr=lptr->next;
			}
			dtmp=rtmp->body;
			while(dtmp){
				stmp=dtmp;
				while(stmp){
					fprintf(stderr," %s  ",stmp->symbol);
					stmp=stmp->next;
				}
				dtmp=dtmp->list;
				fprintf(stderr,"\n");
			}
			fprintf(stderr,"->");
			dtmp=rtmp->head;
			fprintf(stderr,"\n");
			while(dtmp){
				stmp=dtmp;
				while(stmp){
					fprintf(stderr," %s  ",stmp->symbol);
					stmp=stmp->next;
				}
				dtmp=dtmp->list;
				fprintf(stderr,"\n");
			}
			fprintf(stderr,"\n");
			DebugMeta(rtmp->mbdy,"body");
			DebugMeta(rtmp->mhd,"head");
			rtmp=rtmp->next;
		}
	}
}

void useageMessage(void)
{
	fprintf(stderr,"Useage: psgrnd -r rulefile -d datafilelist [-c name=value ...] [-o [filename]]\n");

}
int main(int argc,char **argv)
{
	int i,aflag=0,rfiles=0,dfiles=0,meta;
	char ofilename[180];
	char tmpname[180];
	char rfilename[180];
	char datafiles[20][180];

	NumErrMess=0;

	fprintf(stderr, "Version %s\n",VERSION);
	strcpy(ofilename,"");
	strcpy(tmpname,"");
	Plist=NULL;
	Clist=NULL;
	Dlist=NULL;
	Vlist=NULL;
	Rlist=NULL;
	VTree=NULL;
	if((tmplist=(char **)malloc(sizeof(char *)*MAXVSYMBOL))==NULL){
		fprintf(stderr,"Cannot allocate memory: main\n");
		exit(1);
	}
	for(i=0;i<MAXVSYMBOL;i++)
		if((tmplist[i]=(char *)malloc(sizeof(char)*NAMELEN))==NULL){
			fprintf(stderr,"Cannot allocate memory: main\n");
			exit(1);
		}
	if(argc==1){
		useageMessage();
		exit(1);
	}
	for(i=1;i<argc;i++){
		if(argv[i][0]=='-'){
			switch(argv[i][1]){
				case 'r' : aflag=1; break;
				case 'd' : aflag=2; break;
				case 'c' : aflag=3; break;
				case 'o' : OUTFILE = 1; 
						   aflag=4; 
						   break;
				case 'h' : case 'H' : useageMessage();
					exit(1);
				   break;
				case 'D' : DEBUG=1; 
					aflag=0;
					break;
				case 'C' : CNF=1; 
					aflag=0;
					break;
				default:
					fprintf(stderr,"Invalid option  %s\n",argv[i]);
					exit(1);
			}
		}
		else{
			switch(aflag){
				case 1 : 
					strcpy(rfilename,argv[i]);
					rfiles++;
					aflag=0;
					break;
				case 2 :
					strcpy(datafiles[dfiles++],argv[i]);
					break;
				case 3 :
					strcat(ofilename,ParseConstant(argv[i]));
					strcat(ofilename,"_");
					break;
				case 4 :
					strcpy(tmpname,argv[i]);
					break;
				default:
					break;
			}
		}
	}

	if(!dfiles){
		fprintf(stderr,"Error: No data files. Must have at least one data file.\n");
		exit(1);
	}

	for(i=0;i<dfiles;i++){
		ReadFile(datafiles[i],1);
		strcat(ofilename,datafiles[i]);
		strcat(ofilename,"_");
	}
	if(!Dlist) sprintf(ErrorMessages[NumErrMess++], "No Valid data");
	NewData("INT");
	Dlist->arity=1;
	if(DEBUG)
		printf("Reading data complete\n");
	if(DEBUG)
		DebugInfo(1);

	if(rfiles!=1){
		fprintf(stderr,"Error: %i rule files.  Must have exactly one rule file.\n",
			rfiles);
		exit(1);
	}
		
	strcat(ofilename,rfilename);
	if(!CNF)
		strcat(ofilename,".aspps");
	else
		strcat(ofilename,".cnf");
	ReadFile(rfilename,0);

	if(!Plist) sprintf(ErrorMessages[NumErrMess++], "No Valid predicates");
	if(!Vlist) sprintf(ErrorMessages[NumErrMess++], "No Valid  variables ");
	if(!Rlist) sprintf(ErrorMessages[NumErrMess++], "No Valid rules ");

	Instantiate();

	if(OUTFILE){
		if(strlen(tmpname))
			strcpy(ofilename,tmpname);
		if((ofptr=fopen(ofilename,"w+"))==NULL){
			printf("Error: can not open  %s \n",ofilename);
			return(1);
		}
	}
	else ofptr = stdout;
	SetVarID(VTree);

	if(CNF){
		fprintf(ofptr,"p cnf %i %i\n",Nsymbol,Ncls);
		PrintCNF(ofptr);
	}
	else {
		meta = cntMetaAtoms();
		fprintf(ofptr,"p %i %i %i\n",Nsymbol,meta, Ncls);
		PrintAspps(ofptr);
	}

	if(DEBUG)
		DebugInfo(0);
				
	if(ErrorMessage())
		exit(1);

	PrintVar(ofptr,VTree);

	fclose(ofptr);

	exit(0);
}


